#include "includes.h"  

char uartLogBuf[0x40];                  /* buffer used to output debug strings */
extern uint32_t kPressCntr;

/* by default all used callbacks are configured just to output a debug string on uart */
/* debug string includes key being pressed, value read, average value for the channel */
#if(USE_KBD1)
    void kbd1Action(KeypadIdType kbdNum)
    {
        kbdPress[kbdNum] = 0;   /* reset kpress status */
    	sprintf(uartLogBuf,"[%d %d]\t0x%X\t0x%X\n\r",kPressCntr,kbdNum+1,reading[KBD1_ASSIGNED_CHANNEL],average[KBD1_ASSIGNED_CHANNEL]);
    	sendUart(UART_PORT, (uint8_t *)uartLogBuf, strlen(uartLogBuf));
    }
#else
    #define kbd1Action (NULL)
#endif


#if(USE_KBD2)
    void kbd2Action(KeypadIdType kbdNum)
    {
        kbdPress[kbdNum] = 0;   /* reset kpress status */
    	sprintf(uartLogBuf,"[%d %d]\t0x%X\t0x%X\n\r",kPressCntr,kbdNum+1,reading[KBD2_ASSIGNED_CHANNEL],average[KBD2_ASSIGNED_CHANNEL]);
    	sendUart(UART_PORT, (uint8_t *)uartLogBuf, strlen(uartLogBuf)); 
    }
#else
    #define kbd2Action (NULL)
#endif


#if(USE_KBD3)
    void kbd3Action(KeypadIdType kbdNum)
    {
        kbdPress[kbdNum] = 0;   /* reset kpress status */
    	sprintf(uartLogBuf,"[%d %d]\t0x%X\t0x%X\n\r",kPressCntr,kbdNum+1,reading[KBD3_ASSIGNED_CHANNEL],average[KBD3_ASSIGNED_CHANNEL]);
    	sendUart(UART_PORT, (uint8_t *)uartLogBuf, strlen(uartLogBuf));
    }
#else
    #define kbd3Action (NULL)
#endif


#if(USE_KBD4)
    void kbd4Action(KeypadIdType kbdNum)
    {
        kbdPress[kbdNum] = 0;   /* reset kpress status */
    	sprintf(uartLogBuf,"[%d %d]\t0x%X\t0x%X\n\r",kPressCntr,kbdNum+1,reading[KBD4_ASSIGNED_CHANNEL],average[KBD4_ASSIGNED_CHANNEL]);
    	sendUart(UART_PORT, (uint8_t *)uartLogBuf, strlen(uartLogBuf));
    }
#else
    #define kbd4Action (NULL)
#endif


#if(USE_KBD5)
    void kbd5Action(KeypadIdType kbdNum)
    {
        kbdPress[kbdNum] = 0;   /* reset kpress status */
    	sprintf(uartLogBuf,"[%d %d]\t0x%X\t0x%X\n\r",kPressCntr,kbdNum+1,reading[KBD5_ASSIGNED_CHANNEL],average[KBD5_ASSIGNED_CHANNEL]);
    	sendUart(UART_PORT, (uint8_t *)uartLogBuf, strlen(uartLogBuf));
    }
#else
    #define kbd5Action (NULL)
#endif


#if(USE_KBD6)
    void kbd6Action(KeypadIdType kbdNum)
    {
        kbdPress[kbdNum] = 0;   /* reset kpress status */
        sprintf(uartLogBuf,"%d\t0x%x\t0x%x\n\r",kbdNum+1,reading[KBD6_ASSIGNED_CHANNEL],average[KBD6_ASSIGNED_CHANNEL]);
    	sendUart(UART_PORT, (uint8_t *)uartLogBuf, strlen(uartLogBuf));
    }
#else
    #define kbd6Action (NULL)
#endif


#if(USE_KBD7)
    void kbd7Action(KeypadIdType kbdNum)
    {
        kbdPress[kbdNum] = 0;   /* reset kpress status */
    	sprintf(uartLogBuf,"[%d %d]\t0x%X\t0x%X\n\r",kPressCntr,kbdNum+1,reading[KBD7_ASSIGNED_CHANNEL],average[KBD7_ASSIGNED_CHANNEL]);
    	sendUart(UART_PORT, (uint8_t *)uartLogBuf, strlen(uartLogBuf));
    }
#else
    #define kbd7Action (NULL)
#endif


#if(USE_KBD8)
    void kbd8Action(KeypadIdType kbdNum)
    {
        kbdPress[kbdNum] = 0;   /* reset kpress status */
    	sprintf(uartLogBuf,"[%d %d]\t0x%X\t0x%X\n\r",kPressCntr,kbdNum+1,reading[KBD8_ASSIGNED_CHANNEL],average[KBD8_ASSIGNED_CHANNEL]);
    	sendUart(UART_PORT, (uint8_t *)uartLogBuf, strlen(uartLogBuf));
    }
#else
    #define kbd8Action (NULL)
#endif

/* this table holds the list of callback functions for the kpress */
const CallbackFctType KeypadAction[NUM_KPAD]  = 
{
    (CallbackFctType) kbd1Action,
    (CallbackFctType) kbd2Action,
    (CallbackFctType) kbd3Action,
    (CallbackFctType) kbd4Action,
    (CallbackFctType) kbd5Action,
    (CallbackFctType) kbd6Action,
    (CallbackFctType) kbd7Action,
    (CallbackFctType) kbd8Action        
};
