#ifndef __TPAN_CONFIG_H__
#define __TPAN_CONFIG_H__

/***************************************************/
/* User configuration part */
/***************************************************/

/* defined kpads */
typedef enum {
        KBD1 = 0,
        KBD2,
        KBD3,
        KBD4,
        KBD5,
        KBD6,
        KBD7,
        KBD8,
        NUM_KPAD,
        UNUSED_KPAD
} KeypadIdType;

/* in this file user has to define the different keypads used */
/* each needs to be mapped to a separated ADC channel */

/*-----------------------------------------*/
/* Keypad 1 */
/*-----------------------------------------*/
#define USE_KBD1 0
#if(USE_KBD1 == 1)
    #define KBD1_ASSIGNED_CHANNEL   (x)
    #define CH7_ASSIGNED_KBD        (y)
#endif

/*-----------------------------------------*/
/* Keypad 2 */
/*-----------------------------------------*/
#define USE_KBD2 0
#if(USE_KBD2 == 1)
    #define KBD2_ASSIGNED_CHANNEL   (CH7)
    #define CH7_ASSIGNED_KBD        (KBD2)
#endif

/*-----------------------------------------*/
/* Keypad 3 */
/*-----------------------------------------*/
#define USE_KBD3 0
#if(USE_KBD3 == 1)
    #define KBD3_ASSIGNED_CHANNEL   (CH6)
    #define CH6_ASSIGNED_KBD        (KBD3)
#endif

/*-----------------------------------------*/
/* Keypad 4 */
/*-----------------------------------------*/
#define USE_KBD4 0
#if(USE_KBD4 == 1)
    #define KBD4_ASSIGNED_CHANNEL   (x)
    #define CH7_ASSIGNED_KBD        (y)
#endif

/*-----------------------------------------*/
/* Keypad 5 */
/*-----------------------------------------*/
#define USE_KBD5 1
#if(USE_KBD5 == 1)
    #define KBD5_ASSIGNED_CHANNEL   (CH2)
    #define CH2_ASSIGNED_KBD        (KBD5)
#endif

/*-----------------------------------------*/
/* Keypad 6 */
/*-----------------------------------------*/
#define USE_KBD6 0
#if(USE_KBD6 == 1)
    #define KBD6_ASSIGNED_CHANNEL   (CH3)
    #define CH3_ASSIGNED_KBD        (KBD6)
#endif

/*-----------------------------------------*/
/* Keypad 7 */
/*-----------------------------------------*/
#define USE_KBD7 0
#if(USE_KBD7 == 1)
    #define KBD7_ASSIGNED_CHANNEL   (x)
    #define CH7_ASSIGNED_KBD        (y)
#endif

/*-----------------------------------------*/
/* Keypad 8 */
/*-----------------------------------------*/
#define USE_KBD8 0
#if(USE_KBD8 == 1)
    #define KBD8_ASSIGNED_CHANNEL   (CH4)
    #define CH4_ASSIGNED_KBD        (KBD8)
#endif
                                            
/*-----------------------------------------*/
/* Debug port */
/*-----------------------------------------*/
#define UART_PORT   3 /* which port for the uart */


/***************************************************/
/* End of User configuration part */
/***************************************************/



/***************************************************/
/* Specify default mappings, do not edit below this line  */
/***************************************************/

/* filling up unused kpads */
#ifndef KBD1_ASSIGNED_CHANNEL
    #define KBD1_ASSIGNED_CHANNEL (UNUSED_CHANNEL)
#endif

#ifndef KBD2_ASSIGNED_CHANNEL
    #define KBD2_ASSIGNED_CHANNEL (UNUSED_CHANNEL)
#endif

#ifndef KBD3_ASSIGNED_CHANNEL
    #define KBD3_ASSIGNED_CHANNEL (UNUSED_CHANNEL)
#endif

#ifndef KBD4_ASSIGNED_CHANNEL
    #define KBD4_ASSIGNED_CHANNEL (UNUSED_CHANNEL)
#endif

#ifndef KBD5_ASSIGNED_CHANNEL
    #define KBD5_ASSIGNED_CHANNEL (UNUSED_CHANNEL)
#endif

#ifndef KBD6_ASSIGNED_CHANNEL
    #define KBD6_ASSIGNED_CHANNEL (UNUSED_CHANNEL)
#endif

#ifndef KBD7_ASSIGNED_CHANNEL
    #define KBD7_ASSIGNED_CHANNEL (UNUSED_CHANNEL)
#endif

#ifndef KBD8_ASSIGNED_CHANNEL
    #define KBD8_ASSIGNED_CHANNEL (UNUSED_CHANNEL)
#endif

///* check KBD1 */
//#if(KBD1_ASSIGNED_CHANNEL != UNUSED_CHANNEL)
//    #if(KBD1_ASSIGNED_CHANNEL == KBD2_ASSIGNED_CHANNEL)
//        #error "KBD1 and KBD2 assigned to the same channel"
//    #endif
//    #if(KBD1_ASSIGNED_CHANNEL == KBD3_ASSIGNED_CHANNEL)
//        #error "KBD1 and KBD3 assigned to the same channel"
//    #endif
//    #if(KBD1_ASSIGNED_CHANNEL == KBD4_ASSIGNED_CHANNEL)
//        #error "KBD1 and KBD4 assigned to the same channel"
//    #endif
//    #if(KBD1_ASSIGNED_CHANNEL == KBD5_ASSIGNED_CHANNEL)
//        #error "KBD1 and KBD5 assigned to the same channel"
//    #endif
//    #if(KBD1_ASSIGNED_CHANNEL == KBD6_ASSIGNED_CHANNEL)
//        #error "KBD1 and KBD6 assigned to the same channel"
//    #endif
//    #if(KBD1_ASSIGNED_CHANNEL == KBD7_ASSIGNED_CHANNEL)
//        #error "KBD1 and KBD7 assigned to the same channel"
//    #endif
//    #if(KBD1_ASSIGNED_CHANNEL == KBD8_ASSIGNED_CHANNEL)
//        #error "KBD1 and KBD8 assigned to the same channel"
//    #endif
//#endif
//
///* check KBD2 */
//#if(KBD2_ASSIGNED_CHANNEL != UNUSED_CHANNEL)
//    #if(KBD2_ASSIGNED_CHANNEL == KBD3_ASSIGNED_CHANNEL)
//        #error "KBD2 and KBD3 assigned to the same channel"
//    #endif
//    #if(KBD2_ASSIGNED_CHANNEL == KBD4_ASSIGNED_CHANNEL)
//        #error "KBD2 and KBD4 assigned to the same channel"
//    #endif
//    #if(KBD2_ASSIGNED_CHANNEL == KBD5_ASSIGNED_CHANNEL)
//        #error "KBD2 and KBD5 assigned to the same channel"
//    #endif
//    #if(KBD2_ASSIGNED_CHANNEL == KBD6_ASSIGNED_CHANNEL)
//        #error "KBD2 and KBD6 assigned to the same channel"
//    #endif
//    #if(KBD2_ASSIGNED_CHANNEL == KBD7_ASSIGNED_CHANNEL)
//        #error "KBD2 and KBD7 assigned to the same channel"
//    #endif
//    #if(KBD2_ASSIGNED_CHANNEL == KBD8_ASSIGNED_CHANNEL)
//        #error "KBD2 and KBD8 assigned to the same channel"
//    #endif
//#endif
//
///* check KBD3 */
//#if(KBD3_ASSIGNED_CHANNEL != UNUSED_CHANNEL)
//    #if(KBD3_ASSIGNED_CHANNEL == KBD4_ASSIGNED_CHANNEL)
//        #error "KBD3 and KBD4 assigned to the same channel"
//    #endif
//    #if(KBD3_ASSIGNED_CHANNEL == KBD5_ASSIGNED_CHANNEL)
//        #error "KBD3 and KBD5 assigned to the same channel"
//    #endif
//    #if(KBD3_ASSIGNED_CHANNEL == KBD6_ASSIGNED_CHANNEL)
//        #error "KBD3 and KBD6 assigned to the same channel"
//    #endif
//    #if(KBD3_ASSIGNED_CHANNEL == KBD7_ASSIGNED_CHANNEL)
//        #error "KBD3 and KBD7 assigned to the same channel"
//    #endif
//    #if(KBD3_ASSIGNED_CHANNEL == KBD8_ASSIGNED_CHANNEL)
//        #error "KBD3 and KBD8 assigned to the same channel"
//    #endif
//#endif
//
///* check KBD4 */
//#if(KBD4_ASSIGNED_CHANNEL != UNUSED_CHANNEL)
//    #if(KBD4_ASSIGNED_CHANNEL == KBD5_ASSIGNED_CHANNEL)
//        #error "KBD4 and KBD5 assigned to the same channel"
//    #endif
//    #if(KBD4_ASSIGNED_CHANNEL == KBD6_ASSIGNED_CHANNEL)
//        #error "KBD4 and KBD6 assigned to the same channel"
//    #endif
//    #if(KBD4_ASSIGNED_CHANNEL == KBD7_ASSIGNED_CHANNEL)
//        #error "KBD4 and KBD7 assigned to the same channel"
//    #endif
//    #if(KBD4_ASSIGNED_CHANNEL == KBD8_ASSIGNED_CHANNEL)
//        #error "KBD4 and KBD8 assigned to the same channel"
//    #endif
//#endif
//
///* check KBD5 */
//#if(KBD5_ASSIGNED_CHANNEL != UNUSED_CHANNEL)
//    #if(KBD5_ASSIGNED_CHANNEL == KBD6_ASSIGNED_CHANNEL)
//        #error "KBD5 and KBD6 assigned to the same channel"
//    #endif
//    #if(KBD5_ASSIGNED_CHANNEL == KBD7_ASSIGNED_CHANNEL)
//        #error "KBD5 and KBD7 assigned to the same channel"
//    #endif
//    #if(KBD5_ASSIGNED_CHANNEL == KBD8_ASSIGNED_CHANNEL)
//        #error "KBD5 and KBD8 assigned to the same channel"
//    #endif
//#endif
//
///* check KBD6 */
//#if(KBD6_ASSIGNED_CHANNEL != UNUSED_CHANNEL)
//    #if(KBD6_ASSIGNED_CHANNEL == KBD7_ASSIGNED_CHANNEL)
//        #error "KBD6 and KBD7 assigned to the same channel"
//    #endif
//    #if(KBD6_ASSIGNED_CHANNEL == KBD8_ASSIGNED_CHANNEL)
//        #error "KBD6 and KBD8 assigned to the same channel"
//    #endif
//#endif
//
///* check KBD7 */
//#if(KBD7_ASSIGNED_CHANNEL != UNUSED_CHANNEL)
//    #if(KBD7_ASSIGNED_CHANNEL == KBD8_ASSIGNED_CHANNEL)
//        #error "KBD7 and KBD8 assigned to the same channel"
//    #endif
//#endif


/* filling up unused channels   */
#ifndef CH0_ASSIGNED_KBD
    #define CH0_ASSIGNED_KBD (UNUSED_KPAD)
#endif

#ifndef CH1_ASSIGNED_KBD
    #define CH1_ASSIGNED_KBD (UNUSED_KPAD)
#endif

#ifndef CH2_ASSIGNED_KBD
    #define CH2_ASSIGNED_KBD (UNUSED_KPAD)
#endif

#ifndef CH3_ASSIGNED_KBD
    #define CH3_ASSIGNED_KBD (UNUSED_KPAD)
#endif

#ifndef CH4_ASSIGNED_KBD
    #define CH4_ASSIGNED_KBD (UNUSED_KPAD)
#endif

#ifndef CH5_ASSIGNED_KBD
    #define CH5_ASSIGNED_KBD (UNUSED_KPAD)
#endif

#ifndef CH6_ASSIGNED_KBD
    #define CH6_ASSIGNED_KBD (UNUSED_KPAD)
#endif
#ifndef CH7_ASSIGNED_KBD
    #define CH7_ASSIGNED_KBD (UNUSED_KPAD)
#endif


///* check Ch0 */
//#if(CH0_ASSIGNED_KBD != UNUSED_KPAD)
//    #if(CH0_ASSIGNED_KBD == CH1_ASSIGNED_KBD)
//        #error "CH0 and CH1 assigned to the same kpad"
//    #endif
//    #if(CH0_ASSIGNED_KBD == CH2_ASSIGNED_KBD)
//        #error "CH0 and CH2 assigned to the same kpad"
//    #endif
//    #if(CH0_ASSIGNED_KBD == CH3_ASSIGNED_KBD)
//        #error "CH0 and CH3 assigned to the same kpad"
//    #endif
//    #if(CH0_ASSIGNED_KBD == CH4_ASSIGNED_KBD)
//        #error "CH0 and CH4 assigned to the same kpad"
//    #endif
//    #if(CH0_ASSIGNED_KBD == CH5_ASSIGNED_KBD)
//        #error "CH0 and CH5 assigned to the same kpad"
//    #endif
//    #if(CH0_ASSIGNED_KBD == CH6_ASSIGNED_KBD)
//        #error "CH0 and CH6 assigned to the same kpad"
//    #endif
//    #if(CH0_ASSIGNED_KBD == CH7_ASSIGNED_KBD)
//        #error "CH0 and CH7 assigned to the same kpad"
//    #endif
//#endif
//
///* check Ch1 */
//#if(CH1_ASSIGNED_KBD != UNUSED_KPAD)
//    #if(CH1_ASSIGNED_KBD == CH2_ASSIGNED_KBD)
//        #error "CH1 and CH2 assigned to the same kpad"
//    #endif
//    #if(CH1_ASSIGNED_KBD == CH3_ASSIGNED_KBD)
//        #error "CH1 and CH3 assigned to the same kpad"
//    #endif
//    #if(CH1_ASSIGNED_KBD == CH4_ASSIGNED_KBD)
//        #error "CH1 and CH4 assigned to the same kpad"
//    #endif
//    #if(CH1_ASSIGNED_KBD == CH5_ASSIGNED_KBD)
//        #error "CH1 and CH5 assigned to the same kpad"
//    #endif
//    #if(CH1_ASSIGNED_KBD == CH6_ASSIGNED_KBD)
//        #error "CH1 and CH6 assigned to the same kpad"
//    #endif
//    #if(CH1_ASSIGNED_KBD == CH7_ASSIGNED_KBD)
//        #error "CH1 and CH7 assigned to the same kpad"
//    #endif
//#endif
//
///* check Ch2 */
//#if(CH2_ASSIGNED_KBD != UNUSED_KPAD)
//    #if(CH2_ASSIGNED_KBD == CH3_ASSIGNED_KBD)
//        #error "CH2 and CH3 assigned to the same kpad"
//    #endif
//    #if(CH2_ASSIGNED_KBD == CH4_ASSIGNED_KBD)
//        #error "CH2 and CH4 assigned to the same kpad"
//    #endif
//    #if(CH2_ASSIGNED_KBD == CH5_ASSIGNED_KBD)
//        #error "CH2 and CH5 assigned to the same kpad"
//    #endif
//    #if(CH2_ASSIGNED_KBD == CH6_ASSIGNED_KBD)
//        #error "CH2 and CH6 assigned to the same kpad"
//    #endif
//    #if(CH2_ASSIGNED_KBD == CH7_ASSIGNED_KBD)
//        #error "CH2 and CH7 assigned to the same kpad"
//    #endif
//#endif
//
///* check Ch3 */
//#if(CH3_ASSIGNED_KBD != UNUSED_KPAD)
//    #if(CH3_ASSIGNED_KBD == CH3_ASSIGNED_KBD)
//        #error "CH3 and CH3 assigned to the same kpad"
//    #endif
//    #if(CH3_ASSIGNED_KBD == CH4_ASSIGNED_KBD)
//        #error "CH3 and CH4 assigned to the same kpad"
//    #endif
//    #if(CH3_ASSIGNED_KBD == CH5_ASSIGNED_KBD)
//        #error "CH3 and CH5 assigned to the same kpad"
//    #endif
//    #if(CH3_ASSIGNED_KBD == CH6_ASSIGNED_KBD)
//        #error "CH3 and CH6 assigned to the same kpad"
//    #endif
//    #if(CH3_ASSIGNED_KBD == CH7_ASSIGNED_KBD)
//        #error "CH3 and CH7 assigned to the same kpad"
//    #endif
//#endif
//
///* check Ch4 */
//#if(CH4_ASSIGNED_KBD != UNUSED_KPAD)
//    #if(CH4_ASSIGNED_KBD == CH4_ASSIGNED_KBD)
//        #error "CH4 and CH4 assigned to the same kpad"
//    #endif
//    #if(CH4_ASSIGNED_KBD == CH5_ASSIGNED_KBD)
//        #error "CH4 and CH5 assigned to the same kpad"
//    #endif
//    #if(CH4_ASSIGNED_KBD == CH6_ASSIGNED_KBD)
//        #error "CH4 and CH6 assigned to the same kpad"
//    #endif
//    #if(CH4_ASSIGNED_KBD == CH7_ASSIGNED_KBD)
//        #error "CH4 and CH7 assigned to the same kpad"
//    #endif
//#endif
//
///* check Ch5 */
//#if(CH5_ASSIGNED_KBD != UNUSED_KPAD)
//    #if(CH5_ASSIGNED_KBD == CH5_ASSIGNED_KBD)
//        #error "CH5 and CH5 assigned to the same kpad"
//    #endif
//    #if(CH5_ASSIGNED_KBD == CH6_ASSIGNED_KBD)
//        #error "CH5 and CH6 assigned to the same kpad"
//    #endif
//    #if(CH5_ASSIGNED_KBD == CH7_ASSIGNED_KBD)
//        #error "CH5 and CH7 assigned to the same kpad"
//    #endif
//#endif
//
///* check Ch6 */
//#if(CH6_ASSIGNED_KBD != UNUSED_KPAD)
//    #if(CH6_ASSIGNED_KBD == CH7_ASSIGNED_KBD)
//        #error "CH6 and CH7 assigned to the same kpad"
//    #endif
//#endif

#endif   

/* __TPAN_CONFIG_H__ */
