#include "includes.h"

#define GPIO_1_14		(~(0x3 << 28))
#define GPIO_0_22       (~(0x3 << 12))

/* this function sets the output port as GPIO for the led */
void initLed(void)
{
	#ifdef LPC1759_LPCXPRESSO
        /* P 0.22 led on lpcxpresso stick */
        LPC_GPIO0->FIODIR |= (1<<22);                      
        LPC_PINCON->PINSEL1 &= GPIO_0_22;
	#endif

	#ifdef CUSTOM_BOARD
    	LPC_GPIO1->FIODIR |= (1<<14); 
    	LPC_PINCON->PINSEL2 &= GPIO_1_14;
    #endif
}


/* this function toggles the gpio port (led) */
void toggleLed(void)
{
	#ifdef LPC1759_LPCXPRESSO
		if(LPC_GPIO0->FIOPIN & (1<<22)) clearLed();
		else setLed();
    #endif

	#ifdef CUSTOM_BOARD 
		if(LPC_GPIO1->FIOPIN & (1<<14)) clearLed();
		else setLed();
    #endif

}


